/*

    Quick and Dirty Game Development Framework (QDGDF)

    Simple font handling code.

    Copyright (C) 2001/2005 Angel Ortega <angel@triptico.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://www.triptico.com

*/


#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "qdgdf_video.h"

/** data **/

/* the font glyphs */
static unsigned int *_font = NULL;

/**
 * _qdgdfv_font_height - Height of the font, in pixels.
 *
 * This variable holds the height of the currently
 * loaded font, in pixels.
 * [Font Variables]
 */
int _qdgdfv_font_height = 16;

/* the default font */
unsigned int _default_ktl_font[] =
{
   0x10,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x81,0xE7,
   0xA5,0x99,0x81,0x99,0x42,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x7E,0xFF,
   0x99,0xDB,0xE7,0xFF,0xE7,0x7E,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x66,0xFF,0xFF,0xFF,0xFF,0x7E,0x3C,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x18,0x3C,0x7E,0xFF,0x7E,0x3C,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x18,0x3C,0x3C,0x5A,0xFF,0xFF,0x5A,0x18,0x3C,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x18,0x3C,0x7E,0xFF,0xFF,0xFF,0x5A,0x18,0x3C,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x3C,0x3C,0x18,0x00,0x00,0x00,0x00,0x00,
   0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xC3,0xC3,0xE7,0xFF,0xFF,0xFF,0xFF,
   0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x42,0x42,0x66,0x3C,0x00,0x00,
   0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xC3,0x99,0xBD,0xBD,0x99,0xC3,0xFF,
   0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x0F,0x07,0x0D,0x18,0x3E,0x63,0xC3,0xC3,0xC6,
   0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xC3,0xC3,0xC3,0x7E,0x18,0x18,0x1E,
   0x78,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x0C,0x0E,0x0B,0x08,0x08,0x08,
   0x78,0xF8,0x70,0x00,0x00,0x00,0x00,0x00,0x10,0x18,0x1C,0x16,0x1A,0x16,0x12,
   0x72,0xF2,0x62,0x0E,0x1E,0x0C,0x00,0x00,0x00,0x00,0x18,0x18,0xDB,0x7E,0x3C,
   0xFF,0x3C,0x7E,0xDB,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x60,0x70,0x78,0x7C,
   0x7E,0x7E,0x7C,0x78,0x70,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x0E,0x1E,
   0x3E,0x7E,0x7E,0x3E,0x1E,0x0E,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x38,
   0x7C,0xFE,0x38,0x38,0x38,0x38,0xFE,0x7C,0x38,0x10,0x00,0x00,0x00,0x00,0x66,
   0x66,0x66,0x66,0x66,0x66,0x66,0x00,0x66,0x66,0x00,0x00,0x00,0x00,0x00,0x00,
   0x3F,0x7B,0xDB,0xDB,0xDB,0x7F,0x3B,0x1B,0x1B,0x1B,0x00,0x00,0x00,0x00,0x00,
   0x1F,0x30,0x78,0xDC,0xCE,0xE7,0x73,0x3B,0x1E,0x0C,0x18,0x30,0xE0,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x7E,0x7E,0x7E,0x00,0x00,0x00,
   0x00,0x00,0x00,0x10,0x38,0x7C,0xFE,0x38,0x38,0x38,0xFE,0x7C,0x38,0x10,0x00,
   0xFE,0x00,0x00,0x00,0x10,0x38,0x7C,0xFE,0x38,0x38,0x38,0x38,0x38,0x38,0x38,
   0x38,0x00,0x00,0x00,0x00,0x38,0x38,0x38,0x38,0x38,0x38,0x38,0x38,0xFE,0x7C,
   0x38,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x0C,0xFE,0xFF,0xFE,0x0C,
   0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x30,0x7F,0xFF,0x7F,
   0x30,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0xCC,0x66,0x33,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x24,0x66,0xFF,
   0xFF,0x66,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x3C,0x3C,
   0x7E,0x7E,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
   0x7E,0x7E,0x3C,0x3C,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x33,
   0x66,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x33,0x33,0xFF,0x66,0x66,0x66,0x66,0xFF,0xCC,0xCC,0x00,0x00,0x00,0x00,0x00,
   0x18,0x7E,0xDB,0xD8,0x78,0x1C,0x1E,0x1B,0xDB,0xDB,0x7E,0x18,0x00,0x00,0x00,
   0x00,0x00,0x60,0xD1,0xB3,0x66,0x0C,0x18,0x36,0x6D,0xCB,0x06,0x00,0x00,0x00,
   0x00,0x00,0x00,0x1C,0x36,0x66,0x3C,0x38,0x6C,0xC7,0xC6,0x6E,0x3B,0x00,0x00,
   0x00,0x00,0x00,0x00,0x0C,0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x30,0x30,0x18,
   0x0C,0x00,0x00,0x00,0x00,0x30,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x0C,0x0C,
   0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x66,0x3C,0xFF,0x3C,0x66,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x7E,0x18,
   0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x0C,0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x04,0x0C,
   0x08,0x18,0x10,0x30,0x20,0x60,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,
   0xC3,0xC3,0xC3,0xCF,0xDB,0xF3,0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,
   0x1C,0x3C,0x6C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
   0x3E,0x63,0xC3,0x03,0x06,0x0C,0x18,0x30,0x63,0xFF,0x00,0x00,0x00,0x00,0x00,
   0x00,0xFF,0xC6,0x0C,0x18,0x3E,0x03,0x03,0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,
   0x00,0x00,0x06,0x0E,0x1E,0x36,0x66,0xC7,0xDE,0xF6,0x06,0x06,0x00,0x00,0x00,
   0x00,0x00,0x00,0x1F,0xF0,0xC0,0xDC,0xF6,0x03,0x03,0xC3,0xC6,0x7C,0x00,0x00,
   0x00,0x00,0x00,0x00,0x3C,0x66,0xC6,0xC0,0xDC,0xF6,0xC6,0xC6,0xCC,0x78,0x00,
   0x00,0x00,0x00,0x00,0x00,0xFF,0xC3,0x06,0x0C,0x0C,0x18,0x18,0x30,0x30,0x30,
   0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0xC6,0x6C,0x3E,0x63,0xC3,0xC3,0xC6,
   0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0xC6,0xC6,0xDE,0x76,0x06,0xC6,
   0xCC,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,
   0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,
   0x00,0x18,0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x0C,0x18,0x30,0x60,
   0x60,0x30,0x18,0x0C,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
   0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x18,
   0x0C,0x06,0x06,0x0C,0x18,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,
   0xC6,0x0C,0x18,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,
   0x33,0x6F,0xDB,0xDB,0xDB,0xDE,0xD8,0xC6,0xDC,0x70,0x00,0x00,0x00,0x00,0x00,
   0x18,0x18,0x3C,0x24,0x66,0x6E,0x7A,0xE3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,
   0x00,0x1E,0x33,0xE3,0xC6,0xDC,0xF7,0xC3,0xC6,0xDC,0xF0,0x00,0x00,0x00,0x00,
   0x00,0x00,0x1E,0x33,0x60,0xC0,0xC0,0xC0,0xC0,0xC0,0x63,0x3E,0x00,0x00,0x00,
   0x00,0x00,0x00,0xFC,0xC6,0xC3,0xC3,0xC3,0xC3,0xC3,0xC6,0xDC,0xF0,0x00,0x00,
   0x00,0x00,0x00,0x00,0x1E,0xF0,0xC0,0xC0,0xDC,0xF0,0xC0,0xC0,0xDE,0xF0,0x00,
   0x00,0x00,0x00,0x00,0x00,0x1E,0xF0,0xC0,0xC0,0xDC,0xF0,0xC0,0xC0,0xC0,0xC0,
   0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0xC0,0xC0,0xC0,0xCF,0xC3,0xC3,0x66,
   0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0xC3,0xCF,0xFB,0xC3,0xC3,
   0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x38,0x18,0x18,0x18,0x18,0x18,
   0x18,0x1C,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x03,0x03,0x03,0x03,0x03,
   0xC3,0xC3,0x63,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC6,0xDC,0xF0,0xE0,
   0xF0,0xD8,0xCC,0xC6,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0xC0,0xC0,
   0xC0,0xC0,0xC0,0xC0,0xDE,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xE7,
   0xEF,0xFB,0xD3,0xC3,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,
   0xE3,0xF3,0xD3,0xDB,0xCF,0xC7,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,
   0x63,0xC3,0xC3,0xC3,0xC3,0xC3,0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
   0x1E,0x33,0xE3,0xC3,0xC6,0xDC,0xF0,0xC0,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,
   0x00,0x3E,0x63,0xC3,0xC3,0xC3,0xC3,0xF3,0xDE,0xCC,0x7C,0x06,0x03,0x00,0x00,
   0x00,0x00,0x1E,0x33,0xE3,0xC3,0xC6,0xFC,0xD8,0xCC,0xC6,0xC3,0x00,0x00,0x00,
   0x00,0x00,0x00,0x7E,0xC3,0xC0,0x70,0x1C,0x06,0x03,0xC3,0xC3,0x7E,0x00,0x00,
   0x00,0x00,0x00,0x00,0x0F,0xF8,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,
   0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0xC3,0xC3,0xC3,0xC6,0xC6,0xCC,0x78,
   0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0xC3,0x66,0x66,0x7C,0x38,0x30,
   0x30,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0xC3,0xDB,0xDB,0xDB,0xFF,
   0xE7,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0x66,0x66,0x3C,0x3C,0x66,
   0x66,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0x66,0x66,0x3C,0x18,
   0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xF6,0x04,0x0C,0x18,
   0x10,0x30,0x20,0x6F,0xF8,0x00,0x00,0x00,0x00,0x00,0x3E,0x30,0x30,0x30,0x30,
   0x30,0x30,0x30,0x30,0x30,0x30,0x3E,0x00,0x00,0x00,0x00,0x00,0xC0,0x40,0x60,
   0x20,0x30,0x10,0x18,0x08,0x0C,0x04,0x06,0x00,0x00,0x00,0x00,0x7C,0x0C,0x0C,
   0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x7C,0x00,0x00,0x00,0x00,0x18,0x3C,
   0x66,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,
   0x00,0x30,0x18,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x1F,0x73,0xC3,0xCF,0x7B,0x00,0x00,0x00,
   0x00,0x00,0x00,0xC0,0xC0,0xC0,0xDC,0xF6,0xC3,0xC3,0xC6,0xDC,0xF0,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x60,0xC0,0xC0,0xC3,0x7E,0x00,
   0x00,0x00,0x00,0x00,0x00,0x03,0x03,0x03,0x1F,0x73,0xC3,0xC7,0xCF,0xDB,0x73,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0xCE,0xF8,0xC0,0xC3,
   0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x30,0x30,0x3C,0xF0,0x30,0x30,
   0x30,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x63,0xC3,0xC7,
   0xCF,0xDB,0x73,0x03,0xC3,0x7E,0x00,0x00,0x00,0xC0,0xC0,0xC0,0xCE,0xDB,0xF3,
   0xE3,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x0C,0x00,0x0C,
   0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0xCC,0xCC,0x78,0x00,0x00,0x00,0xC0,0xC0,0xC0,
   0xC6,0xCC,0xD8,0xF8,0xEC,0xC6,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0xE6,0xDB,0xDB,0xDB,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0xCE,0xDB,0xF3,0xE3,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x3E,0x63,0xC3,0xC3,0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0xCE,0xDB,0xF3,0xE3,0xC3,0xC6,0xFC,0xC0,0xC0,0xC0,
   0x00,0x00,0x00,0x00,0x00,0x00,0x73,0xDB,0xCF,0xC7,0xC3,0x63,0x3F,0x03,0x03,
   0x03,0x00,0x00,0x00,0x00,0x00,0x00,0xCE,0xDB,0xF3,0xE0,0xC0,0xC0,0xC0,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xC3,0x70,0x1E,0x03,0xC3,0x7E,
   0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x30,0x30,0x3C,0xF0,0x30,0x30,0x36,0x3C,
   0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0xC7,0xCF,
   0xDB,0x73,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,0x66,
   0x6C,0x38,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0xC3,0xC3,
   0xDB,0xDB,0xFF,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,0x66,
   0x3C,0x18,0x3C,0x66,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3,
   0xC3,0xC3,0xC3,0xC3,0x66,0x3E,0x0C,0xD8,0x70,0x00,0x00,0x00,0x00,0x00,0x00,
   0xFF,0x06,0x0C,0x18,0x30,0x60,0xFF,0x00,0x00,0x00,0x00,0x00,0x0E,0x18,0x18,
   0x18,0x18,0x70,0x70,0x18,0x18,0x18,0x18,0x0E,0x00,0x00,0x00,0x00,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x70,
   0x18,0x18,0x18,0x18,0x0E,0x0E,0x18,0x18,0x18,0x18,0x70,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x76,0xDC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x10,0x38,0x6C,0xC6,0xC6,0xC6,0xFE,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x1E,0x33,0x60,0xC0,0xC0,0xC0,0xC0,0xC0,0x63,0x3E,0x0C,0x18,
   0xF0,0x00,0x00,0x00,0x66,0x66,0x00,0xC3,0xC3,0xC3,0xC7,0xCF,0xDB,0x73,0x00,
   0x00,0x00,0x00,0x00,0x06,0x0C,0x18,0x00,0x3E,0x63,0xCE,0xF8,0xC0,0xC3,0x7E,
   0x00,0x00,0x00,0x00,0x0C,0x1E,0x33,0x60,0x00,0x3E,0x63,0x1F,0x73,0xC3,0xCF,
   0x7B,0x00,0x00,0x00,0x00,0x00,0x00,0x36,0x36,0x00,0x3E,0x63,0x1F,0x73,0xC3,
   0xCF,0x7B,0x00,0x00,0x00,0x00,0x00,0x30,0x18,0x0C,0x00,0x3E,0x63,0x1F,0x73,
   0xC3,0xCF,0x7B,0x00,0x00,0x00,0x00,0x1C,0x36,0x36,0x1C,0x00,0x3E,0x63,0x1F,
   0x73,0xC3,0xCF,0x7B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,
   0x60,0xC0,0xC0,0xC3,0x7E,0x0C,0x18,0xF0,0x00,0x18,0x3C,0x66,0xC0,0x00,0x3E,
   0x63,0xCE,0xF8,0xC0,0xC3,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x00,
   0x3E,0x63,0xCE,0xF8,0xC0,0xC3,0x7E,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x18,
   0x00,0x3E,0x63,0xCE,0xF8,0xC0,0xC3,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x66,
   0x66,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x18,0x3C,
   0x66,0xC0,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
   0x60,0x30,0x18,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,
   0x66,0x66,0x18,0x18,0x3C,0x24,0x66,0x66,0x7E,0xC3,0xC3,0xC3,0x00,0x00,0x00,
   0x00,0x18,0x24,0x24,0x18,0x3C,0x24,0x66,0x66,0x7E,0xC3,0xC3,0xC3,0x00,0x00,
   0x00,0x00,0x18,0x30,0x60,0x1E,0xF0,0xC0,0xDE,0xF0,0xC0,0xC0,0xDE,0xF0,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xDB,0x3B,0x7E,0xDC,0xDB,0x6E,
   0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x3E,0x3C,0x6C,0x6F,0x6E,0x7C,0xCC,0xCF,
   0xCE,0x00,0x00,0x00,0x00,0x18,0x3C,0x66,0xC0,0x00,0x3E,0x63,0xC3,0xC3,0xC3,
   0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x00,0x3E,0x63,0xC3,0xC3,
   0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x18,0x00,0x3E,0x63,0xC3,
   0xC3,0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,0x18,0x3C,0x66,0xC0,0x00,0xC3,0xC3,
   0xC3,0xC7,0xCF,0xDB,0x73,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x18,0x00,0xC3,
   0xC3,0xC3,0xC7,0xCF,0xDB,0x73,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x00,
   0xC3,0xC3,0xC3,0xC3,0xC3,0x66,0x3E,0x0C,0xD8,0x70,0x00,0x66,0x00,0x3E,0x63,
   0xC3,0xC3,0xC3,0xC3,0xC3,0xC3,0xC6,0x7C,0x00,0x00,0x00,0x00,0x66,0x00,0xC3,
   0xC3,0xC3,0xC3,0xC3,0xC3,0xC6,0xC6,0xCC,0x78,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x08,0x08,0x1E,0x3B,0x68,0xC8,0xC8,0xCB,0x7E,0x08,0x08,0x00,0x00,0x00,
   0x00,0x3C,0x66,0x60,0xF8,0x60,0xF8,0x60,0x60,0x63,0x7E,0x00,0x00,0x00,0x00,
   0x00,0x00,0xC3,0xC3,0x66,0x66,0x3C,0x18,0x7E,0x18,0x7E,0x18,0x18,0x00,0x00,
   0x00,0x00,0x00,0x1E,0x33,0xE3,0xC3,0xC6,0xDC,0xF8,0xCC,0xDE,0xCC,0x0F,0x0E,
   0x04,0x00,0x00,0x00,0x1E,0x33,0x30,0x30,0x3C,0xF0,0x30,0x30,0x30,0x30,0xE0,
   0x00,0x00,0x00,0x00,0x06,0x0C,0x18,0x00,0x3E,0x63,0x1F,0x73,0xC3,0xCF,0x7B,
   0x00,0x00,0x00,0x00,0x00,0x06,0x0C,0x18,0x00,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x00,0x00,0x00,0x00,0x00,0x06,0x0C,0x18,0x00,0x3E,0x63,0xC3,0xC3,0xC3,
   0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x0C,0x18,0x30,0x00,0xC3,0xC3,0xC3,0xC7,
   0xCF,0xDB,0x73,0x00,0x00,0x00,0x00,0x00,0x03,0x76,0xDC,0x00,0xCE,0xDB,0xF3,
   0xE3,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x03,0x76,0xDC,0x00,0xC3,0xE3,0xF3,
   0xD3,0xDB,0xCF,0xC7,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x1F,0x73,
   0xC3,0xCF,0x7B,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0xC3,
   0xC3,0xC3,0xC6,0x7C,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x0C,
   0x00,0x0C,0x0C,0x18,0x30,0x63,0xC6,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0xFE,0xC0,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0xFE,0x06,0x06,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x60,0xE1,0x63,0x66,0x6C,0x18,0x30,0x60,0xCE,0x9B,0x06,0x0D,0x1F,0x00,0x00,
   0x00,0x60,0xE1,0x63,0x66,0x6C,0x18,0x30,0x66,0xCE,0x97,0x3E,0x06,0x06,0x00,
   0x00,0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x36,0x6C,0xD8,0xD8,0x6C,0x36,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6C,0x36,0x1B,0x1B,0x36,0x6C,0xC0,
   0x00,0x00,0x00,0x00,0x82,0x10,0x82,0x10,0x82,0x10,0x82,0x10,0x82,0x10,0x82,
   0x10,0x82,0x10,0x82,0x10,0x00,0x95,0x00,0xA9,0x00,0x95,0x00,0xA9,0x00,0x95,
   0x00,0xA9,0x00,0x95,0x00,0xA9,0x92,0x49,0x92,0x49,0x92,0x49,0x92,0x49,0x92,
   0x49,0x92,0x49,0x92,0x49,0x92,0x49,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0xF8,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0xF8,0xF8,0xF8,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0xFC,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0xFC,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x00,0x00,0x00,
   0x00,0x00,0x00,0xF8,0xF8,0xF8,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0xFC,0xFC,0xFC,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x00,0x00,0x00,0x00,0x00,0x00,0xFC,0xFC,0xFC,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFC,0xFC,0xFC,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFC,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0xF8,0xF8,0xF8,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x1F,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xFF,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x1F,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0x18,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0x1F,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3F,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3F,0x3F,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x3F,0x3F,0x3F,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3F,0x3F,0x3F,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFF,0xFF,0xFF,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x18,0x18,0x18,0x18,0x18,0x18,0xFF,0xFF,0xFF,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFF,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
   0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0xFF,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,
   0x18,0x1F,0x1F,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x1F,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x3F,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,
   0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0xFF,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x3C,0x18,
   0x18,0x18,0x18,0x18,0x18,0xFF,0xFF,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
   0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
   0xFF,0xFF,0xFF,0xFF,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
   0xF0,0xF0,0xF0,0xF0,0xF0,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,
   0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x76,0xCC,
   0xCC,0xCC,0xDE,0x73,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0xE3,0xC2,0xCC,
   0xC2,0xC3,0xC3,0xCE,0xD8,0xC0,0xC0,0x00,0x00,0x00,0x00,0x1F,0xF3,0xC3,0xC0,
   0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,
   0x7E,0xE6,0x66,0x66,0x66,0x66,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xF0,
   0x60,0x30,0x18,0x30,0x60,0xC0,0xDF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x7F,0xF0,0xD8,0xD8,0xD8,0xD8,0x70,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x67,0x6F,0x7B,0x60,0x60,0xC0,0x00,0x00,
   0x00,0x00,0x00,0x6F,0xB8,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,0x00,
   0x00,0x00,0x18,0x18,0x7E,0xDB,0xDB,0xDB,0xDB,0x7E,0x18,0x18,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x3C,0x66,0xC3,0xC3,0xFF,0xC3,0xC3,0x66,0x3C,0x00,0x00,
   0x00,0x00,0x00,0x00,0x3C,0x66,0xC3,0xC3,0xC3,0xC3,0x66,0x24,0xA5,0xE7,0x00,
   0x00,0x00,0x00,0x00,0x07,0x1C,0x30,0x18,0x0C,0x3E,0x66,0xC6,0xC6,0xCC,0x78,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0xDB,0xDB,0xDB,0x76,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x04,0x7C,0xCE,0xD6,0xE6,0x7C,
   0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x30,0x60,0x60,0x7E,0x60,0x60,
   0x60,0x30,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xC3,0xC3,0xC3,0xC3,
   0xC3,0xC3,0xC3,0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,
   0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,
   0x7E,0x18,0x18,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x18,
   0x0C,0x06,0x0C,0x18,0x30,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,
   0x18,0x30,0x60,0x30,0x18,0x0C,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x0E,0x1B,0x1B,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
   0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xD8,0xD8,0x70,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x18,0x18,0x00,0xFF,0x00,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x76,0xDC,0x00,0x76,0xDC,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x3C,0x66,0x66,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x02,0x06,0x04,0x0C,0x08,0xD8,0x50,0x70,
   0x20,0x00,0x00,0x00,0x00,0x00,0x00,0xDC,0xF6,0xE6,0xC6,0xC6,0xC6,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xCC,0x18,0x30,0x64,0xFC,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x7E,0x7E,0x7E,
   0x7E,0x7E,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

/**
 * _qdgdfv_font_blend - Blending percentage for font printing.
 *
 * This variable holds the color blending percentage for the selected
 * color when printing a string. If it's 100 (the default) the string
 * will be 100% the specified color; lower values mixes the pixels
 * currently on the virtual screen with that of the drawn characters.
 * [Font Variables]
 */
int _qdgdfv_font_blend = 100;

/**
 * _qdgdfv_convert_ktl_to_proportional - Proportional font conversion flag.
 *
 * If this variable is set, KTL fonts are converted to proportional mode
 * (i.e. 'i' letters are narrower and 'M' letters are wider) after
 * loading. This variable must be set before calling qdgdfv_load_ktl_font().
 */
int _qdgdfv_convert_ktl_to_proportional = 1;

/* starting masks */
static unsigned int masks[256];

/* glyph sizes */
static int sizes[256];

/** code **/

static void proportionalize_font(void)
{
	int n;

	/* convert to 'proportional' */
	for (n = 0; n < 256; n++) {
		unsigned int *p = _font + (n * _qdgdfv_font_height);
		unsigned int t = 0;
		unsigned int c;
		int m;

		masks[n] = 0x80000000;
		sizes[n] = 32;

		/* 'orify' all bytes in the glyph */
		for (m = 0; m < _qdgdfv_font_height; m++, p++)
			t |= *p;

		/* find the first left bit */
		while (sizes[n] && ! (masks[n] & t)) {
			masks[n] >>= 1;
			sizes[n]--;
		}

		/* find now the first right bit */
		c = 0x01;
		while (sizes[n] && ! (c & t)) {
			c <<= 1;
			sizes[n]--;
		}
	}

	/* set the size of the space to be the same as the letter 'n' */
	sizes[' '] = sizes['n'];
}


/**
 * qdgdfv_load_ktl_font - Loads a KTL font.
 * @fontfile: the file containing the font
 *
 * Loads a KTL font and sets it as the current font. The KTL fonts
 * are monospaced (8 bit wide) fonts from the Kaplan Graphical
 * Environment. They are used in Space Plumber as well. If @fontfile
 * is NULL, an internal font (the default one) is activated.
 * [Font Functions]
 */
void qdgdfv_load_ktl_font(char * fontfile)
{
	int n;
	unsigned char c;
	FILE * f;

	if (_font != NULL)
		free(_font);

	_font = (unsigned int *) qdgdfv_malloc(
				_qdgdfv_font_height * 256 * sizeof(unsigned int));

	if (fontfile != NULL) {
		f = qdgdfv_fopen(fontfile,"rb");

		/* first char is the font height */
		c = fgetc(f);
		_qdgdfv_font_height = (int) c;

		/* ignore rest of header */
		fseek(f, 7, SEEK_CUR);

		for (n = 0; n < 256 * _qdgdfv_font_height; n++)
			_font[n] = (unsigned int) fgetc(f);

		fclose(f);
	}
	else {
		_qdgdfv_font_height = _default_ktl_font[0];

		memcpy(_font, _default_ktl_font + 8,
			_qdgdfv_font_height * 256 * sizeof(unsigned int));
	}

	/* default masks and sizes for KTL fonts */
	for (n = 0; n < 256; n++) {
		masks[n] = 0x80;
		sizes[n] = 8;
	}

	if (_qdgdfv_convert_ktl_to_proportional)
		proportionalize_font();
}


/**
 * qdgdfv_font_size - Returns the size of a string, in pixels.
 * @string: the string to be measured
 *
 * Returns the size of the @string in pixels.
 * [Font Functions]
 */
int qdgdfv_font_size(char *string)
{
	unsigned char *p = (unsigned char *)string;
	int n;

	for (n = 0; *p != '\0'; p++)
		n += sizes[(int) *p] + 1;

	return n;
}


static unsigned char _iso2ktl(int c)
{
	int n; 
	static unsigned char * _iso =
		(unsigned char *)"\xe1\xe9\xed\xf3\xfa\xf1\xd1\xfc\xa1\xbf";
	static unsigned char * _dos =
		(unsigned char *)"\xa0\x82\xa1\xa2\xa3\xa4\xa5\x81\xad\xa8";

	/* converts the charset (KTL fonts have MSDOS encoding) */
	for (n = 0; _iso[n]; n++) {
		if (_iso[n] == c)
			return _dos[n];
	}

	return(c);
}


/**
 * qdgdfv_font_print - Prints a string on the virtual screen.
 * @x: x position
 * @y: y position
 * @string: string to be written
 * @color: text color
 *
 * Prints the @string on the virtual screen in the specified coordinates.
 * @x and @y are in pixels. If @x is -1, the string is centered; if is -2, the
 * string is right aligned. If @y is negative, it starts counting from below.
 * [Font Functions]
 */
void qdgdfv_font_print(int x, int y, unsigned char *string, unsigned char color)
{
	unsigned char * screen;
	unsigned char black;

	if (_font == NULL)
		qdgdfv_load_ktl_font(NULL);

	if (string == NULL)
		return;

	if (x == -1) {
		/* -1, center string */
		x = (_qdgdfv_screen_x_size / 2) -
			(qdgdfv_font_size((char *) string) / 2);
	}
	else
	if(x == -2) {
		/* -2, right align */
		x = _qdgdfv_screen_x_size -
			qdgdfv_font_size((char *) string);
	}

	/* if y is negative, start counting from below */
	if (y < 0)
		y = _qdgdfv_screen_y_size + y - _qdgdfv_font_height;

	screen = _qdgdfv_virtual_screen + x + (y * _qdgdfv_screen_x_size);

	/* pick black for character shadowing */
	black = qdgdfv_seek_color(0, 0, 0);

	while (*string != '\0') {
		int n;
		unsigned char cc	= _iso2ktl(*string);
		unsigned int *i		= _font + (cc * _qdgdfv_font_height);
		unsigned char *o	= screen;
		int size			= sizes[cc];
		int mask			= masks[cc];

		for (n = 0; n < _qdgdfv_font_height; n++, i++) {
			int m;
			unsigned int c = *i;

			for (m = 0; m < size; m++) {
				if (mask & c) {
					*o = qdgdfv_blend_color(
						color,
						*o,
						_qdgdfv_font_blend);

					*(o + _qdgdfv_screen_x_size + 1) = black;
				}

				c <<= 1;
				o++;
			}

			o += _qdgdfv_screen_x_size - size;
		}

		screen += (size + 1);
		string++;
	}
}
